<template>
  <q-card :square="!isDesktopPlatform">
    <div
      v-if="loading"
      class="column flex-center"
    >
      <q-card-section>
        <q-spinner-dots
          color="primary"
          size="24px"
        />
      </q-card-section>
    </div>

    <FertilizationPlanList
      v-if="fertilizationPlans && fertilizationPlans.length"
      :fertilization-plans="fertilizationPlans"
    />

    <q-card-section
      v-else
      class="text-body2 text-grey"
    >
      <translate>No fertilization plan</translate>
    </q-card-section>

    <q-card-actions
      v-if="plot"
      align="right"
      class="q-pr-md q-pb-md q-pt-sm"
    >
      <NewFertilizationPlanButton :new-plan-options="{plot: plot}" />
    </q-card-actions>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import NewFertilizationPlanButton from 'src/pages/fieldbook/fertilization/components/NewFertilizationPlanButton'
import FertilizationPlanList from 'src/pages/fieldbook/fertilization/components/FertilizationPlanList'
import queryPlotFertilizationPlans from 'src/pages/holding-campaign/plot/graphql/queryPlotFertilizationPlans'

export default {
  name: 'PlotFertilizationPlansCard',
  mixins: [
    PlatformMixin
  ],
  components: {
    NewFertilizationPlanButton,
    FertilizationPlanList
  },
  props: {
    plotId: {
      type: Number,
      required: true
    }
  },
  computed: {
    loading () {
      return !this.plot && this.$apollo.queries.plot.loading
    },
    fertilizationPlans () {
      return this.plot?.fertilization_plans
    }
  },
  apollo: {
    plot: {
      query: queryPlotFertilizationPlans,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  }
}
</script>
